# Summary

[Introduction](index.md)

---

- [Python Modules](module.md)
- [Python Functions](function.md)
- [Python Classes](class.md)
  - [Class customizations](class/protocols.md)
    - [Basic object customization](class/object.md)
    - [Emulating numeric types](class/numeric.md)
    - [Emulating callable objects](class/call.md)
- [Type Conversions](conversions.md)
  - [Mapping of Rust types to Python types](conversions/tables.md)]
  - [Conversion traits](conversions/traits.md)]
- [Python Exceptions](exception.md)
- [Calling Python from Rust](python_from_rust.md)
- [GIL, mutability and object types](types.md)
- [Parallelism](parallelism.md)
- [Debugging](debugging.md)
- [Features Reference](features.md)
- [Memory Management](memory.md)
- [Advanced Topics](advanced.md)
- [Building and Distribution](building_and_distribution.md)
  - [Supporting multiple Python versions](building_and_distribution/multiple_python_versions.md)
- [Useful Crates](ecosystem.md)
  - [Logging](ecosystem/logging.md)
  - [Async / Await](ecosystem/async-await.md)
- [FAQ & Troubleshooting](faq.md)

---

[Appendix A: Migration Guide](migration.md)
[Appendix B: PyO3 and rust-cpython](rust_cpython.md)
[Appendix C: Trait bounds](trait_bounds.md)
[Appendix D: Python typing hints](python_typing_hints.md)
[CHANGELOG](changelog.md)
